Panda3D

- Main Page
- Packages
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions

# GraphicsOutput Class Reference

This is a base class for the various different classes that represent the result of a frame of rendering. More...

Inheritance diagram for GraphicsOutput:

List of all members.

## Public Types
enum | FrameMode { FMRender = 0, FMParasite = 1, FMRefresh = 2 }
enum | RenderTextureMode { RTMNone = 0, RTMBindOrCopy = 1, RTMCopyTexture = 2, RTMCopyRam = 3, RTMTriggeredCopyTexture = 4, RTMTriggeredCopyRam = 5 }
## Public Member Functions
| addRenderTexture (Texture tex, RenderTextureMode mode, RenderTexturePlane bitplane)
| Creates a new Texture object, suitable for rendering the contents of this buffer into, and appends it to the list of render textures.
| addRenderTexture (Texture tex, RenderTextureMode mode)
| Creates a new Texture object, suitable for rendering the contents of this buffer into, and appends it to the list of render textures.
| clearChildSort ()
| Resets the sort value of future offscreen buffers created by make_texture_sort() to the default value.
| clearDeleteFlag ()
| Resets the delete flag, so the GraphicsOutput will not be automatically deleted before the beginning of the next frame.
| clearRenderTextures ()
| If the GraphicsOutput is currently rendering to a texture, then all textures are dissociated from the GraphicsOuput.
int | countTextures ()
| If the GraphicsOutput is set to render into a texture, returns the number of textures that are being rendered into.
DisplayRegion | getActiveDisplayRegion (int n)
| Returns the nth active DisplayRegion of those that have been created within the window.
list | getActiveDisplayRegions ()
int | getChildSort ()
| Returns the sort value of future offscreen buffers created by make_texture_sort().
bool | getDeleteFlag ()
| Returns the current setting of the delete flag.
DisplayRegion | getDisplayRegion (int n)
| Returns the nth DisplayRegion of those that have been created within the window.
list | getDisplayRegions ()
GraphicsEngine | getEngine ()
| Returns the graphics engine that created this output.
FrameBufferProperties const | getFbProperties ()
| Returns the framebuffer properties of the window.
int | getFbXSize ()
| Returns the internal width of the window or buffer.
int | getFbYSize ()
| Returns the internal height of the window or buffer.
GraphicsStateGuardian | getGsg ()
| Returns the GSG that is associated with this window.
bool | getInverted ()
| Returns the current setting of the inverted flag.
unsigned int | getLeftEyeColorMask ()
| Returns the color mask in effect when rendering a left-eye view in red_blue stereo mode.
string | getName ()
| Returns the name that was passed to the GraphicsOutput constructor.
int | getNumActiveDisplayRegions ()
| Returns the number of active DisplayRegions that have been created within the window.
int | getNumDisplayRegions ()
| Returns the number of DisplayRegions that have been created within the window, active or otherwise.
bool | getOneShot ()
| Returns the current setting of the one-shot flag.
DisplayRegion | getOverlayDisplayRegion ()
| Returns the special "overlay" DisplayRegion that is created for each window or buffer.
GraphicsPipe | getPipe ()
| Returns the GraphicsPipe that this window is associated with.
bool | getRedBlueStereo ()
| Returns whether red-blue stereo mode is in effect for this particular window.
unsigned int | getRightEyeColorMask ()
| Returns the color mask in effect when rendering a right-eye view in red_blue stereo mode.
RenderTextureMode | getRtmMode (int i)
| Returns the RenderTextureMode associated with the nth render-texture.
RenderTextureMode | getRtmMode ()
| Returns the RenderTextureMode associated with the nth render-texture.
VBase4 const | getSbsLeftDimensions ()
| Returns the effective sub-region of the window for displaying the left channel, if side-by-side stereo mode is in effect for the window.
int | getSbsLeftXSize ()
| If side-by-side stereo is enabled, this returns the pixel width of the left eye, based on scaling get_x_size() by get_sbs_left_dimensions().
int | getSbsLeftYSize ()
| If side-by-side stereo is enabled, this returns the pixel height of the left eye, based on scaling get_y_size() by get_sbs_left_dimensions().
VBase4 const | getSbsRightDimensions ()
| Returns the effective sub-region of the window for displaying the right channel, if side-by-side stereo mode is in effect for the window.
int | getSbsRightXSize ()
| If side-by-side stereo is enabled, this returns the pixel width of the right eye, based on scaling get_x_size() by get_sbs_right_dimensions().
int | getSbsRightYSize ()
| If side-by-side stereo is enabled, this returns the pixel height of the right eye, based on scaling get_y_size() by get_sbs_right_dimensions().
bool | getScreenshot (PNMImage image)
| Captures the most-recently rendered image from the framebuffer into the indicated PNMImage.
Texture | getScreenshot ()
| Captures the most-recently rendered image from the framebuffer and returns it as Texture, or NULL on failure.
bool | getSideBySideStereo ()
| Returns whether side-by-side stereo mode is in effect for this particular window.
int | getSort ()
| Returns the sorting order of this particular GraphicsOutput.
bool | getSupportsRenderTexture ()
| Returns true if this particular GraphicsOutput can render directly into a texture, or false if it must always copy-to-texture at the end of each frame to achieve this effect.
bool | getSwapEyes ()
| Returns the current setting of the "swap eyes" flag.
Texture | getTexture ()
| Returns the nth texture into which the GraphicsOutput renders.
Texture | getTexture (int i)
| Returns the nth texture into which the GraphicsOutput renders.
NodePath | getTextureCard ()
| Returns a PandaNode containing a square polygon.
RenderTexturePlane | getTexturePlane (int i)
| Returns the RenderTexturePlane associated with the nth render-texture.
RenderTexturePlane | getTexturePlane ()
| Returns the RenderTexturePlane associated with the nth render-texture.
int | getXSize ()
| Returns the visible width of the window or buffer, if it is known.
int | getYSize ()
| Returns the visible height of the window or buffer, if it is known.
bool | hasSize ()
| Returns true if the size of the window/frame buffer is known, false otherwise.
bool | hasTexture ()
| Returns true if the GraphicsOutput is rendering into any textures at all.
bool | isActive ()
| Returns true if the window is ready to be rendered into, false otherwise.
bool | isNonzeroSize ()
| Returns true if the output has a nonzero size in both X and Y, or false if it is zero (and therefore invalid).
bool | isStereo ()
| Returns Returns true if this window can render stereo DisplayRegions, either through red-blue stereo (see set_red_blue_stereo()) or through true hardware stereo rendering.
bool | isValid ()
| Returns true if the output is fully created and ready for rendering, false otherwise.
GraphicsOutput | makeCubeMap (string name, int size, NodePath camera_rig)
| This is similar to make_texture_buffer() in that it allocates a separate buffer suitable for rendering to a texture that can be assigned to geometry in this window, but in this case, the buffer is set up to render the six faces of a cube map.
GraphicsOutput | makeCubeMap (string name, int size, NodePath camera_rig, BitMaskunsigned int, 32 camera_mask, bool to_ram)
| This is similar to make_texture_buffer() in that it allocates a separate buffer suitable for rendering to a texture that can be assigned to geometry in this window, but in this case, the buffer is set up to render the six faces of a cube map.
GraphicsOutput | makeCubeMap (string name, int size, NodePath camera_rig, BitMaskunsigned int, 32 camera_mask)
| This is similar to make_texture_buffer() in that it allocates a separate buffer suitable for rendering to a texture that can be assigned to geometry in this window, but in this case, the buffer is set up to render the six faces of a cube map.
GraphicsOutput | makeCubeMap (string name, int size, NodePath camera_rig, BitMaskunsigned int, 32 camera_mask, bool to_ram, FrameBufferProperties fbp)
| This is similar to make_texture_buffer() in that it allocates a separate buffer suitable for rendering to a texture that can be assigned to geometry in this window, but in this case, the buffer is set up to render the six faces of a cube map.
DisplayRegion | makeDisplayRegion (float l, float r, float b, float t)
| Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.
DisplayRegion | makeDisplayRegion ()
| Creates a new DisplayRegion that covers the entire window.
DisplayRegion | makeDisplayRegion (VBase4 const dimensions)
| Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.
DisplayRegion | makeMonoDisplayRegion (VBase4 const dimensions)
| Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.
DisplayRegion | makeMonoDisplayRegion ()
| Creates a new DisplayRegion that covers the entire window.
DisplayRegion | makeMonoDisplayRegion (float l, float r, float b, float t)
| Creates a new DisplayRegion that covers the entire window.
StereoDisplayRegion | makeStereoDisplayRegion (float l, float r, float b, float t)
| Creates a new DisplayRegion that covers the entire window.
StereoDisplayRegion | makeStereoDisplayRegion ()
| Creates a new DisplayRegion that covers the entire window.
StereoDisplayRegion | makeStereoDisplayRegion (VBase4 const dimensions)
| Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.
GraphicsOutput | makeTextureBuffer (string name, int x_size, int y_size, Texture tex, bool to_ram)
| Creates and returns an offscreen buffer for rendering into, the result of which will be a texture suitable for applying to geometry within the scene rendered into this window.
GraphicsOutput | makeTextureBuffer (string name, int x_size, int y_size, Texture tex, bool to_ram, FrameBufferProperties fbp)
| Creates and returns an offscreen buffer for rendering into, the result of which will be a texture suitable for applying to geometry within the scene rendered into this window.
GraphicsOutput | makeTextureBuffer (string name, int x_size, int y_size)
| Creates and returns an offscreen buffer for rendering into, the result of which will be a texture suitable for applying to geometry within the scene rendered into this window.
GraphicsOutput | makeTextureBuffer (string name, int x_size, int y_size, Texture tex)
| Creates and returns an offscreen buffer for rendering into, the result of which will be a texture suitable for applying to geometry within the scene rendered into this window.
| removeAllDisplayRegions ()
| Removes all display regions from the window, except the default one that is created with the window.
bool | removeDisplayRegion (DisplayRegion display_region)
| Removes the indicated DisplayRegion from the window, and destructs it if there are no other references.
bool | saveScreenshot (Filename const filename, string image_comment)
| Saves a screenshot of the region to the indicated filename.
bool | saveScreenshot (Filename const filename)
| Saves a screenshot of the region to the indicated filename.
Filename | saveScreenshotDefault ()
| Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.
Filename | saveScreenshotDefault (string prefix)
| Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.
| setActive (bool active)
| Sets the active flag associated with the GraphicsOutput.
| setChildSort (int child_sort)
| Specifies the sort value of future offscreen buffers created by make_texture_sort().
| setInverted (bool inverted)
| Changes the current setting of the inverted flag.
| setOneShot (bool one_shot)
| Changes the current setting of the one-shot flag.
| setOverlayDisplayRegion (DisplayRegion display_region)
| Replaces the special "overlay" DisplayRegion that is created for each window or buffer.
| setRedBlueStereo (bool red_blue_stereo, unsigned int left_eye_color_mask, unsigned int right_eye_color_mask)
| Enables red-blue stereo mode on this particular window.
| setSideBySideStereo (bool side_by_side_stereo, VBase4 const sbs_left_dimensions, VBase4 const sbs_right_dimensions)
| Enables side-by-side stereo mode on this particular window.
| setSideBySideStereo (bool side_by_side_stereo)
| Enables side-by-side stereo mode on this particular window.
| setSort (int sort)
| Adjusts the sorting order of this particular GraphicsOutput, relative to other GraphicsOutputs.
| setSwapEyes (bool swap_eyes)
| Changes the "swap eyes" flag.
| setupRenderTexture (Texture tex, bool allow_bind, bool to_ram)
| This is a deprecated interface that made sense back when GraphicsOutputs could only render into one texture at a time.
bool | shareDepthBuffer (GraphicsOutput graphics_output)
| Will attempt to use the depth buffer of the input graphics_output.
| triggerCopy ()
| When the GraphicsOutput is in triggered copy mode, this function triggers the copy (at the end of the next frame).
| unshareDepthBuffer ()
| Discontinue sharing the depth buffer.
## Static Public Member Functions
static TypeHandle | getClassType ()
static Filename | makeScreenshotFilename (string prefix)
| Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.
static Filename | makeScreenshotFilename ()
| Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.

## Detailed Description

This is a base class for the various different classes that represent the result of a frame of rendering.

The most common kind of GraphicsOutput is a GraphicsWindow, which is a real-time window on the desktop, but another example is GraphicsBuffer, which is an offscreen buffer.

The actual rendering, and anything associated with the graphics context itself, is managed by the associated GraphicsStateGuardian (which might output to multiple GraphicsOutput objects).

GraphicsOutputs are not actually writable to bam files, of course, but they may be passed as event parameters, so they inherit from TypedWritableReferenceCount instead of TypedReferenceCount for that convenience.

## Member Enumeration Documentation

enum FrameMode

Enumerator:

  FMRender |
  FMParasite |
  FMRefresh |

enum RenderTextureMode

Enumerator:

  RTMNone |
  RTMBindOrCopy |
  RTMCopyTexture |
  RTMCopyRam |
  RTMTriggeredCopyTexture |
  RTMTriggeredCopyRam |

## Member Function Documentation

addRenderTexture | ( | Texture | tex,
|  | RenderTextureMode | mode,
|  | RenderTexturePlane | bitplane
| ) |  |

Creates a new Texture object, suitable for rendering the contents of this buffer into, and appends it to the list of render textures.

If tex is not NULL, it is the texture that will be set up for rendering into; otherwise, a new Texture object will be created, in which case you may call get_texture() to retrieve the new texture pointer.

You can specify a bitplane to attach the texture to. the legal choices are:

RTP_depth RTP_depth_stencil RTP_color RTP_aux_rgba_0 RTP_aux_rgba_1 RTP_aux_rgba_2 RTP_aux_rgba_3

If you do not specify a bitplane to attach the texture to, this routine will use a default based on the texture's format:

F_depth_component attaches to RTP_depth F_depth_stencil attaches to RTP_depth_stencil all other formats attach to RTP_color.

The texture's format will be changed to match the format of the bitplane to which it is attached. For example, if you pass in an F_rgba texture and order that it be attached to RTP_depth_stencil, it will turn into an F_depth_stencil texture.

Also see make_texture_buffer(), which is a higher-level interface for preparing render-to-a-texture mode.

addRenderTexture | ( | Texture | tex,
|  | RenderTextureMode | mode
| ) |  |

Creates a new Texture object, suitable for rendering the contents of this buffer into, and appends it to the list of render textures.

If tex is not NULL, it is the texture that will be set up for rendering into; otherwise, a new Texture object will be created, in which case you may call get_texture() to retrieve the new texture pointer.

You can specify a bitplane to attach the texture to. the legal choices are:

RTP_depth RTP_depth_stencil RTP_color RTP_aux_rgba_0 RTP_aux_rgba_1 RTP_aux_rgba_2 RTP_aux_rgba_3

If you do not specify a bitplane to attach the texture to, this routine will use a default based on the texture's format:

F_depth_component attaches to RTP_depth F_depth_stencil attaches to RTP_depth_stencil all other formats attach to RTP_color.

The texture's format will be changed to match the format of the bitplane to which it is attached. For example, if you pass in an F_rgba texture and order that it be attached to RTP_depth_stencil, it will turn into an F_depth_stencil texture.

Also see make_texture_buffer(), which is a higher-level interface for preparing render-to-a-texture mode.

clearChildSort | ( |  | ) |

Resets the sort value of future offscreen buffers created by make_texture_sort() to the default value.

See set_child_sort().

clearDeleteFlag | ( |  | ) |

Resets the delete flag, so the GraphicsOutput will not be automatically deleted before the beginning of the next frame.

clearRenderTextures | ( |  | ) |

If the GraphicsOutput is currently rendering to a texture, then all textures are dissociated from the GraphicsOuput.

int countTextures | ( |  | ) |

If the GraphicsOutput is set to render into a texture, returns the number of textures that are being rendered into.

Normally, the textures would be associated with different buffers - a color texture, a depth texture, and a stencil texture.

DisplayRegion getActiveDisplayRegion | ( | int | n | ) |

Returns the nth active DisplayRegion of those that have been created within the window.

This may return NULL if n is out of bounds; particularly likely if the number of display regions has changed since the last call to get_num_active_display_regions().

list getActiveDisplayRegions | ( |  | ) |

int getChildSort | ( |  | ) |

Returns the sort value of future offscreen buffers created by make_texture_sort().

See set_child_sort().

static TypeHandle getClassType | ( |  | ) | `[static]`

Reimplemented from GraphicsOutputBase.

Reimplemented in GraphicsWindow, CallbackGraphicsWindow, GraphicsBuffer, and ParasiteBuffer.

bool getDeleteFlag | ( |  | ) |

Returns the current setting of the delete flag.

When this is true, the GraphicsOutput will automatically be removed before the beginning of the next frame by the GraphicsEngine.

DisplayRegion getDisplayRegion | ( | int | n | ) |

Returns the nth DisplayRegion of those that have been created within the window.

This may return NULL if n is out of bounds; particularly likely if the number of display regions has changed since the last call to get_num_display_regions().

list getDisplayRegions | ( |  | ) |

GraphicsEngine getEngine | ( |  | ) |

Returns the graphics engine that created this output.

Since there is normally only one GraphicsEngine object in an application, this is usually the same as the global GraphicsEngine.

FrameBufferProperties const getFbProperties | ( |  | ) |

Returns the framebuffer properties of the window.

int getFbXSize | ( |  | ) |

Returns the internal width of the window or buffer.

This is almost always the same as get_x_size(), except when a pixel_zoom is in effect--see set_pixel_zoom().

int getFbYSize | ( |  | ) |

Returns the internal height of the window or buffer.

This is almost always the same as get_y_size(), except when a pixel_zoom is in effect--see set_pixel_zoom().

GraphicsStateGuardian getGsg | ( |  | ) |

Returns the GSG that is associated with this window.

There is a one-to-one association between windows and GSG's.

This may return NULL if the graphics context has not yet been created for the window, e.g. before the first frame has rendered; or after the window has been closed.

bool getInverted | ( |  | ) |

Returns the current setting of the inverted flag.

When this is true, the scene is rendered into the window upside-down, flipped like a mirror along the X axis. See set_inverted().

unsigned int getLeftEyeColorMask | ( |  | ) |

Returns the color mask in effect when rendering a left-eye view in red_blue stereo mode.

This is one or more bits defined in ColorWriteAttrib.Channels. See set_red_blue_stereo().

string getName | ( |  | ) |

Returns the name that was passed to the GraphicsOutput constructor.

int getNumActiveDisplayRegions | ( |  | ) |

Returns the number of active DisplayRegions that have been created within the window.

int getNumDisplayRegions | ( |  | ) |

Returns the number of DisplayRegions that have been created within the window, active or otherwise.

bool getOneShot | ( |  | ) |

Returns the current setting of the one-shot flag.

When this is true, the GraphicsOutput will automatically set itself inactive after the next frame.

DisplayRegion getOverlayDisplayRegion | ( |  | ) |

Returns the special "overlay" DisplayRegion that is created for each window or buffer.

This DisplayRegion covers the entire window, but cannot be used for rendering. It is a placeholder only, to indicate the dimensions of the window, and is usually used internally for purposes such as clearing the window, or grabbing a screenshot of the window.

There are very few applications that require access to this DisplayRegion. Normally, you should create your own DisplayRegion that covers the window, if you want to render to the window.

GraphicsPipe getPipe | ( |  | ) |

Returns the GraphicsPipe that this window is associated with.

It is possible that the GraphicsPipe might have been deleted while an outstanding PT(GraphicsOutput) prevented all of its children windows from also being deleted; in this unlikely case, get_pipe() may return NULL.

bool getRedBlueStereo | ( |  | ) |

Returns whether red-blue stereo mode is in effect for this particular window.

See set_red_blue_stereo().

unsigned int getRightEyeColorMask | ( |  | ) |

Returns the color mask in effect when rendering a right-eye view in red_blue stereo mode.

This is one or more bits defined in ColorWriteAttrib.Channels. See set_red_blue_stereo().

RenderTextureMode getRtmMode | ( | int | i | ) |

Returns the RenderTextureMode associated with the nth render-texture.

Returns RTM_none if there is no such texture.

RenderTextureMode getRtmMode | ( |  | ) |

Returns the RenderTextureMode associated with the nth render-texture.

Returns RTM_none if there is no such texture.

VBase4 const getSbsLeftDimensions | ( |  | ) |

Returns the effective sub-region of the window for displaying the left channel, if side-by-side stereo mode is in effect for the window.

See set_side_by_side_stereo().

int getSbsLeftXSize | ( |  | ) |

If side-by-side stereo is enabled, this returns the pixel width of the left eye, based on scaling get_x_size() by get_sbs_left_dimensions().

If side-by-side stereo is not enabled, this returns the same as get_x_size().

int getSbsLeftYSize | ( |  | ) |

If side-by-side stereo is enabled, this returns the pixel height of the left eye, based on scaling get_y_size() by get_sbs_left_dimensions().

If side-by-side stereo is not enabled, this returns the same as get_y_size().

VBase4 const getSbsRightDimensions | ( |  | ) |

Returns the effective sub-region of the window for displaying the right channel, if side-by-side stereo mode is in effect for the window.

See set_side_by_side_stereo().

int getSbsRightXSize | ( |  | ) |

If side-by-side stereo is enabled, this returns the pixel width of the right eye, based on scaling get_x_size() by get_sbs_right_dimensions().

If side-by-side stereo is not enabled, this returns the same as get_x_size().

int getSbsRightYSize | ( |  | ) |

If side-by-side stereo is enabled, this returns the pixel height of the right eye, based on scaling get_y_size() by get_sbs_right_dimensions().

If side-by-side stereo is not enabled, this returns the same as get_y_size().

Texture getScreenshot | ( |  | ) |

Captures the most-recently rendered image from the framebuffer and returns it as Texture, or NULL on failure.

bool getScreenshot | ( | PNMImage | image | ) |

Captures the most-recently rendered image from the framebuffer into the indicated PNMImage.

Returns true on success, false on failure.

bool getSideBySideStereo | ( |  | ) |

Returns whether side-by-side stereo mode is in effect for this particular window.

See set_side_by_side_stereo().

int getSort | ( |  | ) |

Returns the sorting order of this particular GraphicsOutput.

The various GraphicsOutputs within a particular thread will be rendered in the indicated order.

bool getSupportsRenderTexture | ( |  | ) |

Returns true if this particular GraphicsOutput can render directly into a texture, or false if it must always copy-to-texture at the end of each frame to achieve this effect.

bool getSwapEyes | ( |  | ) |

Returns the current setting of the "swap eyes" flag.

See set_swap_eyes().

Texture getTexture | ( |  | ) |

Returns the nth texture into which the GraphicsOutput renders.

Returns NULL if there is no such texture.

If the texture is non-NULL, it may be applied to geometry to be rendered for any other windows or outputs that share the same GSG as this GraphicsOutput. The effect is undefined for windows that share a different GSG; usually in these cases the texture will be invalid.

Reimplemented from GraphicsOutputBase.

Texture getTexture | ( | int | i | ) |

Returns the nth texture into which the GraphicsOutput renders.

Returns NULL if there is no such texture.

If the texture is non-NULL, it may be applied to geometry to be rendered for any other windows or outputs that share the same GSG as this GraphicsOutput. The effect is undefined for windows that share a different GSG; usually in these cases the texture will be invalid.

Reimplemented from GraphicsOutputBase.

NodePath getTextureCard | ( |  | ) |

Returns a PandaNode containing a square polygon.

The dimensions are (-1,0,-1) to (1,0,1). The texture coordinates are such that the texture of this GraphicsOutput is aligned properly to the polygon. The GraphicsOutput promises to surgically update the Geom inside the PandaNode if necessary to maintain this invariant.

Each invocation of this function returns a freshly- allocated PandaNode. You can therefore safely modify the RenderAttribs of the PandaNode. The PandaNode is initially textured with the texture of this GraphicOutput.

RenderTexturePlane getTexturePlane | ( | int | i | ) |

Returns the RenderTexturePlane associated with the nth render-texture.

Returns 0 if there is no such texture.

RenderTexturePlane getTexturePlane | ( |  | ) |

Returns the RenderTexturePlane associated with the nth render-texture.

Returns 0 if there is no such texture.

int getXSize | ( |  | ) |

Returns the visible width of the window or buffer, if it is known.

In certain cases (e.g. fullscreen windows), the size may not be known until after the object has been fully created. Check has_size() first.

Certain objects (like windows) may change size spontaneously; this method is not thread-safe. To get the size of a window in a thread-safe manner, query get_properties().

int getYSize | ( |  | ) |

Returns the visible height of the window or buffer, if it is known.

In certain cases (e.g. fullscreen windows), the size may not be known until after the object has been fully created. Check has_size() first.

Certain objects (like windows) may change size spontaneously; this method is not thread-safe. To get the size of a window in a thread-safe manner, query get_properties().

bool hasSize | ( |  | ) |

Returns true if the size of the window/frame buffer is known, false otherwise.

In certain cases the size may not be known until after the object has been fully created. Also, certain objects (like windows) may change size spontaneously.

bool hasTexture | ( |  | ) |

Returns true if the GraphicsOutput is rendering into any textures at all.

bool isActive | ( |  | ) |

Returns true if the window is ready to be rendered into, false otherwise.

bool isNonzeroSize | ( |  | ) |

Returns true if the output has a nonzero size in both X and Y, or false if it is zero (and therefore invalid).

bool isStereo | ( |  | ) |

Returns Returns true if this window can render stereo DisplayRegions, either through red-blue stereo (see set_red_blue_stereo()) or through true hardware stereo rendering.

bool isValid | ( |  | ) |

Returns true if the output is fully created and ready for rendering, false otherwise.

GraphicsOutput makeCubeMap | ( | string | name,
|  | int | size,
|  | NodePath | camera_rig,
|  | BitMaskunsigned | int,
|  | 32 | camera_mask,
|  | bool | to_ram
| ) |  |

This is similar to make_texture_buffer() in that it allocates a separate buffer suitable for rendering to a texture that can be assigned to geometry in this window, but in this case, the buffer is set up to render the six faces of a cube map.

The buffer is automatically set up with six display regions and six cameras, each of which are assigned the indicated draw_mask and parented to the given camera_rig node (which you should then put in your scene to render the cube map from the appropriate point of view).

You may take the texture associated with the buffer and apply it to geometry, particularly with TexGenAttrib.M_world_cube_map also in effect, to apply a reflection of everything seen by the camera rig.

GraphicsOutput makeCubeMap | ( | string | name,
|  | int | size,
|  | NodePath | camera_rig,
|  | BitMaskunsigned | int,
|  | 32 | camera_mask
| ) |  |

This is similar to make_texture_buffer() in that it allocates a separate buffer suitable for rendering to a texture that can be assigned to geometry in this window, but in this case, the buffer is set up to render the six faces of a cube map.

The buffer is automatically set up with six display regions and six cameras, each of which are assigned the indicated draw_mask and parented to the given camera_rig node (which you should then put in your scene to render the cube map from the appropriate point of view).

You may take the texture associated with the buffer and apply it to geometry, particularly with TexGenAttrib.M_world_cube_map also in effect, to apply a reflection of everything seen by the camera rig.

GraphicsOutput makeCubeMap | ( | string | name,
|  | int | size,
|  | NodePath | camera_rig,
|  | BitMaskunsigned | int,
|  | 32 | camera_mask,
|  | bool | to_ram,
|  | FrameBufferProperties | fbp
| ) |  |

This is similar to make_texture_buffer() in that it allocates a separate buffer suitable for rendering to a texture that can be assigned to geometry in this window, but in this case, the buffer is set up to render the six faces of a cube map.

The buffer is automatically set up with six display regions and six cameras, each of which are assigned the indicated draw_mask and parented to the given camera_rig node (which you should then put in your scene to render the cube map from the appropriate point of view).

You may take the texture associated with the buffer and apply it to geometry, particularly with TexGenAttrib.M_world_cube_map also in effect, to apply a reflection of everything seen by the camera rig.

GraphicsOutput makeCubeMap | ( | string | name,
|  | int | size,
|  | NodePath | camera_rig
| ) |  |

This is similar to make_texture_buffer() in that it allocates a separate buffer suitable for rendering to a texture that can be assigned to geometry in this window, but in this case, the buffer is set up to render the six faces of a cube map.

The buffer is automatically set up with six display regions and six cameras, each of which are assigned the indicated draw_mask and parented to the given camera_rig node (which you should then put in your scene to render the cube map from the appropriate point of view).

You may take the texture associated with the buffer and apply it to geometry, particularly with TexGenAttrib.M_world_cube_map also in effect, to apply a reflection of everything seen by the camera rig.

DisplayRegion makeDisplayRegion | ( | float | l,
|  | float | r,
|  | float | b,
|  | float | t
| ) |  |

Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.

The range on all parameters is 0..1.

If is_stereo() is true for this window, and default-stereo-camera is configured true, this actually makes a StereoDisplayRegion. Call make_mono_display_region() or make_stereo_display_region() if you want to insist on one or the other.

DisplayRegion makeDisplayRegion | ( |  | ) |

Creates a new DisplayRegion that covers the entire window.

If is_stereo() is true for this window, and default-stereo-camera is configured true, this actually makes a StereoDisplayRegion. Call make_mono_display_region() or make_stereo_display_region() if you want to insist on one or the other.

DisplayRegion makeDisplayRegion | ( | VBase4 const | dimensions | ) |

Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.

The range on all parameters is 0..1.

If is_stereo() is true for this window, and default-stereo-camera is configured true, this actually makes a StereoDisplayRegion. Call make_mono_display_region() or make_stereo_display_region() if you want to insist on one or the other.

DisplayRegion makeMonoDisplayRegion | ( | VBase4 const | dimensions | ) |

Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.

The range on all parameters is 0..1.

This generally returns a mono DisplayRegion, even if is_stereo() is true. However, if side-by-side stereo is enabled, this will return a StereoDisplayRegion whose two eyes are both set to SC_mono. (This is necessary because in side-by-side stereo mode, it is necessary to draw even mono DisplayRegions twice).

DisplayRegion makeMonoDisplayRegion | ( |  | ) |

Creates a new DisplayRegion that covers the entire window.

This generally returns a mono DisplayRegion, even if is_stereo() is true. However, if side-by-side stereo is enabled, this will return a StereoDisplayRegion whose two eyes are both set to SC_mono. (This is necessary because in side-by-side stereo mode, it is necessary to draw even mono DisplayRegions twice).

DisplayRegion makeMonoDisplayRegion | ( | float | l,
|  | float | r,
|  | float | b,
|  | float | t
| ) |  |

Creates a new DisplayRegion that covers the entire window.

This generally returns a mono DisplayRegion, even if is_stereo() is true. However, if side-by-side stereo is enabled, this will return a StereoDisplayRegion whose two eyes are both set to SC_mono. (This is necessary because in side-by-side stereo mode, it is necessary to draw even mono DisplayRegions twice).

static Filename makeScreenshotFilename | ( |  | ) | `[static]`

Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.

The default filename is generated from the supplied prefix and from the Config variable screenshot-filename, which contains the following strings:

~p - the supplied prefix ~f - the frame count ~e - the value of screenshot-extension All other % strings in strftime().

static Filename makeScreenshotFilename | ( | string | prefix | ) | `[static]`

Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.

The default filename is generated from the supplied prefix and from the Config variable screenshot-filename, which contains the following strings:

~p - the supplied prefix ~f - the frame count ~e - the value of screenshot-extension All other % strings in strftime().

StereoDisplayRegion makeStereoDisplayRegion | ( | float | l,
|  | float | r,
|  | float | b,
|  | float | t
| ) |  |

Creates a new DisplayRegion that covers the entire window.

This always returns a stereo DisplayRegion, even if is_stereo() is false.

StereoDisplayRegion makeStereoDisplayRegion | ( |  | ) |

Creates a new DisplayRegion that covers the entire window.

This always returns a stereo DisplayRegion, even if is_stereo() is false.

StereoDisplayRegion makeStereoDisplayRegion | ( | VBase4 const | dimensions | ) |

Creates a new DisplayRegion that covers the indicated sub-rectangle within the window.

The range on all parameters is 0..1.

This always returns a stereo DisplayRegion, even if is_stereo() is false.

GraphicsOutput makeTextureBuffer | ( | string | name,
|  | int | x_size,
|  | int | y_size
| ) |  |

Creates and returns an offscreen buffer for rendering into, the result of which will be a texture suitable for applying to geometry within the scene rendered into this window.

If tex is not NULL, it is the texture that will be set up for rendering into; otherwise, a new Texture object will be created. In either case, the target texture can be retrieved from the return value with buffer->get_texture() (assuming the return value is not NULL).

If to_ram is true, the buffer will be set up to download its contents to the system RAM memory associated with the Texture object, instead of keeping it strictly within texture memory; this is much slower, but it allows using the texture with any GSG.

This will attempt to be smart about maximizing render performance while minimizing framebuffer waste. It might return a GraphicsBuffer set to render directly into a texture, if possible; or it might return a ParasiteBuffer that renders into this window. The return value is NULL if the buffer could not be created for some reason.

When you are done using the buffer, you should remove it with a call to GraphicsEngine.remove_window().

GraphicsOutput makeTextureBuffer | ( | string | name,
|  | int | x_size,
|  | int | y_size,
|  | Texture | tex
| ) |  |

Creates and returns an offscreen buffer for rendering into, the result of which will be a texture suitable for applying to geometry within the scene rendered into this window.

If tex is not NULL, it is the texture that will be set up for rendering into; otherwise, a new Texture object will be created. In either case, the target texture can be retrieved from the return value with buffer->get_texture() (assuming the return value is not NULL).

If to_ram is true, the buffer will be set up to download its contents to the system RAM memory associated with the Texture object, instead of keeping it strictly within texture memory; this is much slower, but it allows using the texture with any GSG.

This will attempt to be smart about maximizing render performance while minimizing framebuffer waste. It might return a GraphicsBuffer set to render directly into a texture, if possible; or it might return a ParasiteBuffer that renders into this window. The return value is NULL if the buffer could not be created for some reason.

When you are done using the buffer, you should remove it with a call to GraphicsEngine.remove_window().

GraphicsOutput makeTextureBuffer | ( | string | name,
|  | int | x_size,
|  | int | y_size,
|  | Texture | tex,
|  | bool | to_ram,
|  | FrameBufferProperties | fbp
| ) |  |

Creates and returns an offscreen buffer for rendering into, the result of which will be a texture suitable for applying to geometry within the scene rendered into this window.

If tex is not NULL, it is the texture that will be set up for rendering into; otherwise, a new Texture object will be created. In either case, the target texture can be retrieved from the return value with buffer->get_texture() (assuming the return value is not NULL).

If to_ram is true, the buffer will be set up to download its contents to the system RAM memory associated with the Texture object, instead of keeping it strictly within texture memory; this is much slower, but it allows using the texture with any GSG.

This will attempt to be smart about maximizing render performance while minimizing framebuffer waste. It might return a GraphicsBuffer set to render directly into a texture, if possible; or it might return a ParasiteBuffer that renders into this window. The return value is NULL if the buffer could not be created for some reason.

When you are done using the buffer, you should remove it with a call to GraphicsEngine.remove_window().

GraphicsOutput makeTextureBuffer | ( | string | name,
|  | int | x_size,
|  | int | y_size,
|  | Texture | tex,
|  | bool | to_ram
| ) |  |

Creates and returns an offscreen buffer for rendering into, the result of which will be a texture suitable for applying to geometry within the scene rendered into this window.

If tex is not NULL, it is the texture that will be set up for rendering into; otherwise, a new Texture object will be created. In either case, the target texture can be retrieved from the return value with buffer->get_texture() (assuming the return value is not NULL).

If to_ram is true, the buffer will be set up to download its contents to the system RAM memory associated with the Texture object, instead of keeping it strictly within texture memory; this is much slower, but it allows using the texture with any GSG.

This will attempt to be smart about maximizing render performance while minimizing framebuffer waste. It might return a GraphicsBuffer set to render directly into a texture, if possible; or it might return a ParasiteBuffer that renders into this window. The return value is NULL if the buffer could not be created for some reason.

When you are done using the buffer, you should remove it with a call to GraphicsEngine.remove_window().

removeAllDisplayRegions | ( |  | ) |

Removes all display regions from the window, except the default one that is created with the window.

bool removeDisplayRegion | ( | DisplayRegion | display_region | ) |

Removes the indicated DisplayRegion from the window, and destructs it if there are no other references.

Returns true if the DisplayRegion is found and removed, false if it was not a part of the window.

bool saveScreenshot | ( | Filename const | filename | ) |

Saves a screenshot of the region to the indicated filename.

The image comment is an optional user readable string that will be saved with the header of the image (if the file format supports embedded data; for example jpg allows comments). Returns true on success, false on failure.

bool saveScreenshot | ( | Filename const | filename,
|  | string | image_comment
| ) |  |

Saves a screenshot of the region to the indicated filename.

The image comment is an optional user readable string that will be saved with the header of the image (if the file format supports embedded data; for example jpg allows comments). Returns true on success, false on failure.

Filename saveScreenshotDefault | ( | string | prefix | ) |

Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.

The filename is generated by make_screenshot_filename().

Filename saveScreenshotDefault | ( |  | ) |

Saves a screenshot of the region to a default filename, and returns the filename, or empty string if the screenshot failed.

The filename is generated by make_screenshot_filename().

setActive | ( | bool | active | ) |

Sets the active flag associated with the GraphicsOutput.

If the GraphicsOutput is marked inactive, nothing is rendered.

setChildSort | ( | int | child_sort | ) |

Specifies the sort value of future offscreen buffers created by make_texture_sort().

The purpose of this method is to allow the user to limit the sort value chosen for a buffer created via make_texture_buffer(). Normally, this buffer will be assigned a value of get_sort() - 1, so that it will be rendered before this window is rendered; but sometimes this isn't sufficiently early, especially if other buffers also have a view into the same scene.

If you specify a value here, then new buffers created via make_texture_buffer() will be given that sort value instead of get_sort() - 1.

setInverted | ( | bool | inverted | ) |

Changes the current setting of the inverted flag.

When this is true, the scene is rendered into the window upside-down and backwards, that is, inverted as if viewed through a mirror placed on the floor.

This is primarily intended to support DirectX (and a few buggy OpenGL graphics drivers) that perform a framebuffer-to-texture copy upside-down from the usual OpenGL (and Panda) convention. Panda will automatically set this flag for offscreen buffers on hardware that is known to do this, to compensate when rendering offscreen into a texture.

setOneShot | ( | bool | one_shot | ) |

Changes the current setting of the one-shot flag.

When this is true, the GraphicsOutput will render the current frame and then automatically set itself inactive. This is particularly useful for buffers that are created for the purposes of render-to-texture, for static textures that don't need to be continually re-rendered once they have been rendered the first time.

Setting the buffer inactive is not the same thing as destroying it. You are still responsible for passing this buffer to GraphicsEngine.remove_window() when you no longer need the texture, in order to clean up fully. (However, you should not call remove_window() on this buffer while the texture is still needed, because depending on the render-to-texture mechanism in use, this may invalidate the texture contents.)

setOverlayDisplayRegion | ( | DisplayRegion | display_region | ) |

Replaces the special "overlay" DisplayRegion that is created for each window or buffer.

See get_overlay_display_region(). This must be a new DisplayRegion that has already been created for this window, for instance via a call to make_mono_display_region(). You are responsible for ensuring that the new DisplayRegion covers the entire window. The previous overlay display region is not automatically removed; you must explicitly call remove_display_region() on it after replacing it with this method, if you wish it to be removed.

Normally, there is no reason to change the overlay DisplayRegion, so this method should be used only in very unusual circumstances.

setRedBlueStereo | ( | bool | red_blue_stereo,
|  | unsigned int | left_eye_color_mask,
|  | unsigned int | right_eye_color_mask
| ) |  |

Enables red-blue stereo mode on this particular window.

When red-blue stereo mode is in effect, DisplayRegions that have the "left" channel set will render in the red (or specified) channel only, while DisplayRegions that have the "right" channel set will render in the blue (or specified) channel only.

The remaining two parameters specify the particular color channel(s) to associate with each eye. Use the bits defined in ColorWriteAttrib.Channels.

This can be used to achieve a cheesy stereo mode in the absence of hardware-supported stereo.

setSideBySideStereo | ( | bool | side_by_side_stereo,
|  | VBase4 const | sbs_left_dimensions,
|  | VBase4 const | sbs_right_dimensions
| ) |  |

Enables side-by-side stereo mode on this particular window.

When side-by-side stereo mode is in effect, DisplayRegions that have the "left" channel set will render on the part of the window specified by sbs_left_dimensions (typically the left half: (0, 0.5, 0, 1)), while DisplayRegions that have the "right" channel set will render on the part of the window specified by sbs_right_dimensions (typically the right half: (0.5, 1, 0, 1)).

This is commonly used in a dual-monitor mode, where a window is opened that spans two monitors, and each monitor represents a different eye.

setSideBySideStereo | ( | bool | side_by_side_stereo | ) |

Enables side-by-side stereo mode on this particular window.

When side-by-side stereo mode is in effect, DisplayRegions that have the "left" channel set will render on the part of the window specified by sbs_left_dimensions (typically the left half: (0, 0.5, 0, 1)), while DisplayRegions that have the "right" channel set will render on the part of the window specified by sbs_right_dimensions (typically the right half: (0.5, 1, 0, 1)).

This is commonly used in a dual-monitor mode, where a window is opened that spans two monitors, and each monitor represents a different eye.

setSort | ( | int | sort | ) |

Adjusts the sorting order of this particular GraphicsOutput, relative to other GraphicsOutputs.

Reimplemented from GraphicsOutputBase.

setSwapEyes | ( | bool | swap_eyes | ) |

Changes the "swap eyes" flag.

This flag is normally false. When it is true, the left and right channels of a stereo DisplayRegion are sent to the opposite channels in the rendering backend. This is meant to work around hardware that inadvertently swaps the output channels, or hardware for which it cannot be determined which channel is which until runtime.

setupRenderTexture | ( | Texture | tex,
|  | bool | allow_bind,
|  | bool | to_ram
| ) |  |

This is a deprecated interface that made sense back when GraphicsOutputs could only render into one texture at a time.

From now on, use clear_render_textures and add_render_texture instead.

bool shareDepthBuffer | ( | GraphicsOutput | graphics_output | ) |

Will attempt to use the depth buffer of the input graphics_output.

The buffer sizes must be exactly the same.

triggerCopy | ( |  | ) |

When the GraphicsOutput is in triggered copy mode, this function triggers the copy (at the end of the next frame).

unshareDepthBuffer | ( |  | ) |

Discontinue sharing the depth buffer.

All Classes Namespaces Functions Variables Enumerations Enumerator Properties